ShutUpRolis = {
	name = "ShutUpRolis",
}

function ShutUpRolis:muteIfRolisHlaalu()
	if GetUnitName("interact") == "Rolis Hlaalu" then
		EVENT_MANAGER:RegisterForEvent(ShutUpRolis.name, EVENT_CHATTER_END, ShutUpRolis.restoreDialogVolumeDelayed)

		-- Set Dialog Volume setting to 0
		SetSetting(SETTING_TYPE_AUDIO, AUDIO_SETTING_VO_VOLUME, "0")

		-- Invoke restoreDialogVolumeInstant() before executing ReloadUI(), Logout(), or Quit()
		ZO_PreHook("ReloadUI", ShutUpRolis.restoreDialogVolumeInstant)
		ZO_PreHook("Logout", ShutUpRolis.restoreDialogVolumeInstant)
		ZO_PreHook("Quit", ShutUpRolis.restoreDialogVolumeInstant)
	end
end

function ShutUpRolis:restoreDialogVolumeDelayed()
	local currentDialogVolume = tonumber(GetSetting(SETTING_TYPE_AUDIO, AUDIO_SETTING_VO_VOLUME))
	if currentDialogVolume == 0 then
		EVENT_MANAGER:UnregisterForEvent(ShutUpRolis.name, EVENT_CHATTER_END)
		-- Delay because Rolis doesn't know when to shut up if the player backs out mid sentence. Typical Rolis behavior.
		zo_callLater(function()
			SetSetting(SETTING_TYPE_AUDIO, AUDIO_SETTING_VO_VOLUME, initalDialogVolume)
		end, 500)
	end
end

-- Instant Dialog Volume Restore for PreHooks
function ShutUpRolis:restoreDialogVolumeInstant()
	local currentDialogVolume = tonumber(GetSetting(SETTING_TYPE_AUDIO, AUDIO_SETTING_VO_VOLUME))
	if currentDialogVolume == 0 then
		SetSetting(SETTING_TYPE_AUDIO, AUDIO_SETTING_VO_VOLUME, initalDialogVolume)
	end
end

function ShutUpRolis:handleEventChatterBegin()
	local currentZone = GetZoneId(GetUnitZoneIndex("player"))
	local rolisZoneIds = {
		[383] = true, -- Grahtwood
		[57] = true, -- Deshaan
		[19] = true, -- Stormhaven
	}
	-- Register for EVENT_CHATTER_BEGIN if the player is in a zone where Rolis exists and EVENT_CHATTER_BEGIN is not registered
	if rolisZoneIds[currentZone] and ShutUpRolis_chatterIsRegistered == false then
		EVENT_MANAGER:RegisterForEvent(ShutUpRolis.name, EVENT_CHATTER_BEGIN, ShutUpRolis.muteIfRolisHlaalu)
		ShutUpRolis_chatterIsRegistered = true
	-- Do nothing if the player is in a zone where Rolis exists and EVENT_CHATTER_BEGIN is already registered
	elseif rolisZoneIds[currentZone] and ShutUpRolis_chatterIsRegistered == true then

	-- Unregister for EVENT_CHATTER_BEGIN if the player is NOT in a zone where Rolis exists, and EVENT_CHATTER_BEGIN is already registered
	elseif not rolisZoneIds[currentZone] and ShutUpRolis_chatterIsRegistered == true then
		EVENT_MANAGER:UnregisterForEvent(ShutUpRolis.name, EVENT_CHATTER_BEGIN)
		ShutUpRolis_chatterIsRegistered = false
	else
	end
end

function ShutUpRolis:Initialize()
	EVENT_MANAGER:UnregisterForEvent(ShutUpRolis.name, EVENT_ADD_ON_LOADED)

	EVENT_MANAGER:RegisterForEvent(ShutUpRolis.name, EVENT_PLAYER_ACTIVATED, ShutUpRolis.handleEventChatterBegin)
	initalDialogVolume = tonumber(GetSetting(SETTING_TYPE_AUDIO, AUDIO_SETTING_VO_VOLUME))
	ShutUpRolis_chatterIsRegistered = false
end

function ShutUpRolis.OnAddOnLoaded(event, addonName)
	if addonName == ShutUpRolis.name then
		ShutUpRolis:Initialize()
	end
end

EVENT_MANAGER:RegisterForEvent(ShutUpRolis.name, EVENT_ADD_ON_LOADED, ShutUpRolis.OnAddOnLoaded)
